﻿(function($){
	reader_timer = '';
	viewpoint_array = [];
	viewpoint_time_array = [];
	start_time_array = [];

	$.fn.reader_check = function(viewpoint) {
		$(viewpoint).each(function() {
			viewpoint_array.push($(this).attr('id'));
			viewpoint_time_array.push(0);
			start_time_array.push(0);
		});

		$(this).reader_check_processor(viewpoint_array, viewpoint_time_array, start_time_array);
		return this;
	};

	$.fn.reader_check_processor = function(viewpoint_array, viewpoint_time_array, start_time_array) {
		$(this).reader_check_set(viewpoint_array, viewpoint_time_array, start_time_array);

		$(this).scroll(function() {
			$(this).reader_check_set(viewpoint_array, viewpoint_time_array, start_time_array);
		});

		return this;
	};

	$.fn.reader_check_set = function(viewpoint_array, viewpoint_time_array, start_time_array) {
		var current_viewpoint = $(document).scrollTop() + $(window).height();
		clearTimeout(reader_timer);



		$.each(viewpoint_array, function(i, val) {
			if (($('#'+val).offset().top < current_viewpoint) && ($('#'+val).offset().top + $('#'+val).height() > current_viewpoint - $(window).height())) {
				var now = $.now();
				if (start_time_array[i] == 0) {
					start_time_array[i] = now;
				}

				if (viewpoint_time_array[i] == 0) {
					viewpoint_time_array[i] = now - start_time_array[i];
				}
				else {
					if (now == start_time_array[i]) {
						start_time_array[i] -= viewpoint_time_array[i];
					}
					else {
						viewpoint_time_array[i] = now - start_time_array[i];
					}
				}
			}
			else {
				start_time_array[i] = 0;
			}
		});

		var output_array = [];
		$.each(viewpoint_time_array, function(i, val) {
			output_array.push(parseInt(viewpoint_time_array[i] / 1000));
		});

		var page = window.location.href;
		reader_timer = setTimeout(function() {
			$.ajax({
					url: 'reader.php',
					type: "POST",
					data: ({
						action: 'reader', 
						viewpoint_array: viewpoint_array.join(','), 
						output_array: output_array.join(','), 
						page: page
					}),
					success: function (data) {
					}
				});
		}, 3000);

		return this;
	};
})(jQuery);



window.addEventListener('beforeunload', function(event) {
	var output_array = [];
	$.each(viewpoint_time_array, function(i, val) {
		output_array.push(parseInt(viewpoint_time_array[i] / 1000));
	});

	var page = window.location.href;
	$.ajax({
			url: 'reader.php',
			type: "POST",
			data: ({
				action: 'reader', 
				viewpoint_array: viewpoint_array.join(','), 
				output_array: output_array.join(','), 
				page: page
			}),
			success: function (data) {
			}
		});
});